const random$ = Observable.create(observer => {
  log.info("observable started");
  const timeout = setTimeout(function() {
    log.info('timeout execution');
    observer.next(Math.random());
    observer.complete();
  }, 1000);
  return function unsubscribe() {
    log.info('unsubscribed from observable');
    clearTimeout(timeout);
  }
});

const s1 = random$.subscribe(createLogObserver("#1"));
s1.unsubscribe();
const s2 = random$.subscribe(createLogObserver("#2"));