const unstableApi$ = Observable.create(observer => {
  log.info('trying unstable API access...')
  let timeout = setTimeout(function(){
    if (Math.random() > 0.7) {
      observer.next(true);
      observer.complete();
    } else {
      log.error('failed...');
      observer.error(new Error("request failed"));
    }
  }, 500);
  return function unsubscribe() {
    clearTimeout(timeout);
  }
});

unstableApi$.pipe(rxjs.operators.retry(3)).subscribe(
    createLogObserver()
)